'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable no-console */
/* eslint-disable react/forbid-prop-types */

var MISSING_PROP = 'You must supply at least a "module" or a "modules" prop to the "CodeSplit" component.';

function es6Safe(module) {
  return module.default ? module.default : module;
}

var CodeSplit = function (_Component) {
  _inherits(CodeSplit, _Component);

  function CodeSplit(props) {
    _classCallCheck(this, CodeSplit);

    var _this = _possibleConstructorReturn(this, (CodeSplit.__proto__ || Object.getPrototypeOf(CodeSplit)).call(this, props));

    var _this$props = _this.props;
    var module = _this$props.module;
    var modules = _this$props.modules;
    var moduleCount = _this$props.moduleCount;


    if (!module && !modules) {
      throw new Error(MISSING_PROP);
    }

    var modulesLength = modules ? moduleCount || modules.length : 0;

    _this.state = {
      result: module ? null : Array.from({ length: modulesLength }, function () {
        return null;
      })
    };
    return _this;
  }

  _createClass(CodeSplit, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      var _props = this.props;
      var module = _props.module;
      var modules = _props.modules;
      var transpiled = _props.transpiled;
      var onError = _props.onError;


      if (transpiled) {
        // We will are receiving results for regular "require" expressions.
        this.setState({
          result: module ? es6Safe(module) : modules.map(es6Safe)
        });
      } else {
        // We have a System.import single promise or a Promise.all result.
        (module || modules).then(function (result) {
          return _this2.setState({
            result: module ? es6Safe(result) : result.map(es6Safe)
          });
        }).catch(function (err) {
          return onError ? onError(err) : console.log(err);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      return this.props.children(this.state.result);
    }
  }]);

  return CodeSplit;
}(_react.Component);

CodeSplit.propTypes = {
  module: _react.PropTypes.any,
  modules: _react.PropTypes.any,
  moduleCount: _react.PropTypes.number,
  onError: _react.PropTypes.func,
  children: _react.PropTypes.func.isRequired,
  transpiled: _react.PropTypes.bool
};

exports.default = CodeSplit;